#include "cMIPS.h"
#include "vetorFib.h"
#include "structUart.h"

#define OBOUND_MESG "Out of bounds\n"
#define OVERUN_MESG "Overun\n"
#define MAXPOW 7
#define SPEED 3
#define COUNT ((SPEED+1)*100)

// ----------------------- begin driver?
extern UARTdriver Ud;
volatile Tserial *uart;

int proberx () {
    return Ud.nrx;
}

int probetx () {
    return Ud.ntx;
}

void ioctl (int c) {
    uart->cs.ctl = (unsigned char)c;
}

int ioctl () {
    return uart->cs.stat;
}

int Putc (char c) {
    int ntx = probetx();
    if (ntx == 0)
        return 0;
    if (ntx == 16 && uart->cs.stat.txEmpty)  // Empty Q && Tx
        uart->d.tx = (int) c;                   // 32-bits
    else {                                      // Sending smthng
        disableInterr();
        ud.ntx--;
        // STORE AND THEN INCREMENTS
        Ud.tx_q[Ud.tx_tl] = c;
        Ud.tx_tl = (Ud.tx_tl + 1)&0xF;          // modulo 16
        enableInterr();
    }
    return 1;
}
// ------------------------- end driver?
// ------------------------- begin main()
int Strlen (char *c) {
    int i= 0;
    while(c[i++]-10);
    return i-1;
}

int pow16 (int ex) {
    int i, ret=1;
    for (i= 0; i< ex/2; i++)
        ret*=16;
    ret *= ret;
    return (ex%2?ret*16:ret);
}

int hex2int (char *hex) {
    int s= Strlen(hex), i, ans= 0;
    #if 0
        Test Signal...
    switch (hex[0]) {
        case 'F':
        case 'f':
        case 'E':
        case 'e':
        case 'D':
        case 'd':
        case 'C':
        case 'c':
        case 'B':
        case 'b':
        case 'A':
        case 'a':
        case '9':
            ans = hex[0]*pow16(s-1);
    }
    #endif
    for (i= 0; i< s; i++) {
        hex[i]-= 48;
        if (hex[i] > 9)
            hex[i] -= 7;
        if (hex[i] > 15)
            hex[i] -= 32;
        ans += hex[i] * pow16(s-(i+1));
    }
    return ans;
}

int int2hex (char *c, int i) {
    int j= 0, val;
    int p;
    p = pow16(MAXPOW);
    while (p > 0) {
        val= 0;
        if (i/p) {
            val= i/p;
            i%= p;
        }
        if ((val < 10) && (j || val)) { // impede que '0' sejam escritos à esquerda
            c[j++] = val+'0';
        }
        else if (val > 9)
            c[j++] = 'a'+ (val-10);
        p/=16;
    }
    c[j] = 10;
    return j-1;
}

int main () {
    Tcontrol ctrl;
    char n[16], f[16], c;
    int fib, j, s, val, rx, sent;

    uart= IO_UART_ADDR;
    // initialize UART control
    ctrl.rts= 1;
    ctrl.intTX= 1;              // Both interruption
    ctrl.intRX= 1;
    ctrl.speed= SPEED;
    ioctl((int)ctrl);

    while (1) {
        j= 0;
        /***************************
        **  Reception with tests  **
        ***************************/
        fib= hex2int(n);
        if (fib < BUF_SZ) {
            fib = buf[fib];
            s= int2hex(f, fib);     // retorna strlen de f
            for (j= 0; j< s; j++) {
                // full(!rx_q) && !sent
                while(((rx = proberx()) < 16) && ((sent=Putc(f[j])!= 0)));
                if (rx == 16) {         // rx_q is full
                    // Esvazia rx_q
                }
                if (sent == 0)
                    j--;                // don't send char in this turn
            }
        } else
            for (j= 0; j<sizeof(BOUND_MESG); j++)
                to_stdout(BOUND_MESG[j]);
    }

    startCounter (COUNT , 0);
    while ((val= (readCounter() && 0x3FFFFFFF)) < COUNT);

    return val;
}
