#UARTinterr:
    # There is space on _uart_buff
    # _uart_buff[0]=UARTstatus, [1]=UARTcontrol, [2]=data_inp, [3]=new,
    #           [4]=$ra, [5]=$a0, [6]=$a1, [7]=$a2, [8]=$a3
    #k0 = _uart_buff

    # saving used registers on _uart_buff
    
    sw    $a2, 7*4($k0)
    sw    $a3, 8*4($k0)
    sw    $v0, 9*4($k0)
    sw    $ra, 10*4($k0)

    andi  $a1, $k1, UART_rx_irq # Is this reception?
    bne   $a1, $zero, UARTrxinter #   no, maybe transmission?
    nop
    andi  $a1, $k1, UART_tx_irq # Is this transmission?
    beq   $a1, $zero, UARTret     #   no, it was nothing
    nop

    lui   $a2, %hi(ntx)
    ori   $a2, $a2, %lo(ntx)
    lw    $a1, 0($a2)

#    jal   print
#    move  $a0, $a1

#    lui   $a0, %hi(HW_uart_addr)# get device's addres
#    ori   $a0, $a0, %lo(HW_uart_addr)

    li    $a3, 16
    beq   $a3, $a1, endUH     # empty Q
    nop

    addi  $a1, $a1, 1
    sw    $a1, 0($a2)           # update ntx, one more free space

    # INCREMENTS AND THEN LOAD
    lui   $a2, %hi(tx_q)
    ori   $a2, $a2, %lo(tx_q)
    lui   $a1, %hi(tx_hd)
    ori   $a1, $a1, %lo(tx_hd)
    lw    $a3, 0($a1)
    nop
    addi  $a3, $a3, 1           #increment Q head
    andi  $a3, $a3, 0xf         # modulo 16
    sw    $a3, 0($a1)            # store new head index
    add   $a2, $a2, $a3         # a2 <- &(tx_q[tx_hd])
    lb    $a3, 0($a2)           # get char from Q head
    nop

    sw    $a3, 1*4($a0)            # write char in txreg


endUH: 
    
    lw    $ra, 10*4($k0)
    lw    $v0, 9*4($k0)
    lw    $a3, 8*4($k0)
    b     UARTret
    lw    $a2, 7*4($k0)

UARTrxinter:
    #handle reception
    lw    $a1, 4($a0)           # Read data from device
    nop                         #   and store it to UART's buffer
    sw    $a1, 2*4($k0)         #   and return from interrupt
    addiu $a1, $zero, 1
    sw    $a1, 3*4($k0)         # Signal new arrival
                                #         i have to enqueue it and update nrx.
    
    # check if queue is full, maybe increment
    lui   $a1, %hi(nrx)
    ori   $a1, $a1, %lo(nrx)
    lw    $a3, 0($a1)
    nop
    slti  $a2, $a3, 16
    beq   $a2, $zero, overrun
    nop
    addiu $a3, $a3, 1
    sw    $a3, 0($a1)

    # enqueue
    lui   $a1, %hi(rx_tl)        # get rx tail address
    ori   $a1, $a1, %lo(rx_tl)    

    lw    $a3, 0($a1)
    nop
    addiu $a3, $a3, 1             # increment in 1 the tail of the circular queue
    andi  $a3, $a3, 0xf           # % 16
    sw    $a3, 0($a1)

    #### stores on queue on tail
    lui   $a2, %hi(rx_q)         # get queue address
    ori   $a2, $a2, %lo(rx_q)

    addu  $a2, $a3, $a2            # calculate address to move new char
    lw    $a3, 2*4($k0)          # get char to be stored
    nop
    sb    $a3, 0($a2)             # and store it!
#jal to_stdout 
#move $a0, $a3

    b endUH
    nop

overrun:
    lui   $a1, %hi(proberxs)
    ori   $a1, $a1, %lo(proberxs)
    lw    $a3, 0($a1)
    nop
    
    la    $a2, 0x40000000
    or    $a2, $a2, $a3
    sw    $a2, 0($a1)
    nop

    #jal print
    #move  $a0, $a2 
    # move $a0, $a3
    # do something if rx queue is full or tx is empty
    # set overrun bit on uart statusReg
    #... (doing absolutely nothing besides stacking and unstacking regs)
    #lw $a1, 0*4($k0)            # get status from memory
    #nop
    #ori $a1, $a1, 0x00000001   # set overun bit to 1
    #sw  $a1, 0*4($k0)
    # sw $a1, ???   ---+          Dunno where to save Status
    b endUH         #  |
    nop         #   <--+

