#include "cMIPS.h"
#include "../include/vetorFib.h"
#include "../include/structUart.h"

#define OBOUND_MESG "Out of bounds\n"
#define OVERUN_MESG "Overun\n"
#define MAXPOW 7
#define SPEED 1
#define COUNT ((SPEED+1)*100)

// ----------------------- begin driver?
extern UARTdriver Ud;
volatile Tserial *uart;
#if 0
int proberx () {
    return Ud.nrx;
}

int probetx () {
    return Ud.ntx;
}

void ioctl (int c) {
    uart->cs.ctl = (Tcontrol)c;
}

int iostat() {
    return (int)uart->cs.stat;
}
#endif
int Putc (char c) {
    int ntx = Ud.ntx;
    if (ntx == 0)
        return 0;
    if (ntx == 16 && uart->cs.stat.txEmpty)  // Empty Q && Tx
        uart->d.tx = (unsigned int) c;                   // 32-bits
    else {                                      // Sending smthng
        disableInterr();
        Ud.ntx--;
        // INCREMENTS AND THEN STORE
        Ud.tx_tl = (Ud.tx_tl+1)&0xF;          // modulo 16
        Ud.tx_q[Ud.tx_tl] = c;
        enableInterr();
    }
    return 1;
}
// ------------------------- end driver?
// ------------------------- begin main()
int Strlen (char *c) {
    int i= 0;
    while(c[i++]-10);
    return i-1;
}

int pow16 (int ex) {
    int i, ret=1;
    for (i= 0; i< ex/2; i++)
        ret*=16;
    ret *= ret;
    return (ex%2?ret*16:ret);
}

int hex2int (char *hex) {
    int s= Strlen(hex), i, ans= 0;
    #if 0
        Test Signal...
    switch (hex[0]) {
        case 'F':
        case 'f':
        case 'E':
        case 'e':
        case 'D':
        case 'd':
        case 'C':
        case 'c':
        case 'B':
        case 'b':
        case 'A':
        case 'a':
        case '9':
            ans = hex[0]*pow16(s-1);
    }
    #endif
    for (i= 0; i< s; i++) {
        hex[i]-= 48;
        if (hex[i] > 9)
            hex[i] -= 7;
        if (hex[i] > 15)
            hex[i] -= 32;
        ans += hex[i] * pow16(s-(i+1));
    }
    return ans;
}

int int2hex (char *c, int i) {
    int j= 0, val;
    int p;
    p = pow16(MAXPOW);
    while (p > 0) {
        val= 0;
        if (i/p) {
            val= i/p;
            i%= p;
        }
        if ((val < 10) && (j || val)) { // impede que '0' sejam escritos à esquerda
            c[j++] = val+'0';
        }
        else if (val > 9)
            c[j++] = 'a'+ (val-10);
        p/=16;
    }
    c[j] = 10;
    return j-1;
}

int main () {
    Tcontrol ctrl;
    char p[15]; 
    int fib, j, s, val, rx, sent;
    volatile int *counter;

    counter = (int *)IO_COUNT_ADDR;
    uart= (void *)IO_UART_ADDR;
    // initialize UART control
    ctrl.rts= 0;
    ctrl.intTX= 1;              // Both interruption
    ctrl.intRX= 0;
    ctrl.speed= SPEED;
    uart->cs.ctl = ctrl;

    Ud.ntx = 16;
    for (fib= 0; fib< 44; fib++) {
        int2hex(p, buf[fib]);
        j= -1;
        do {
            j++;
            while (((rx = Ud.nrx) != 16) && (!Putc(p[j])));
            if (rx == 16) {
                // Empty it
                j--;
            }
        } while (p[j] != 0);
    }

    startCounter (COUNT , 0);
    while ((val= (readCounter() && 0x3FFFFFFF)) < COUNT);

    return val;
}
